﻿using System;
using System.Collections.Generic;
using System.Text;

using System.IO;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            String currentDirectory = @"E:\Tmp\XX";//Directory.GetCurrentDirectory();  // Каталог сборки
            //Console.WriteLine(currentDirectory);
            DirectoryInfo directory = new DirectoryInfo(currentDirectory);
            FileInfo[] files1 = directory.GetFiles("*.txt"); // Список текстовых файлов

            // Создаем маску с атрибутами
            FileAttributes mask = FileAttributes.Archive
                | FileAttributes.ReadOnly
                | FileAttributes.System
                | FileAttributes.Offline
                | FileAttributes.NotContentIndexed
                | FileAttributes.Hidden
                | FileAttributes.Temporary
                | FileAttributes.Device;

            // Устанавливаем для всех файлов указанные атрибуты 
            foreach (FileInfo file in files1)
            {
                // Добавляем атрибуты
                file.Attributes |= mask;
            }

            // Создаем новый объект для чистоты эксперимента и печатаем атрибуты
            FileInfo[] files2 = directory.GetFiles("*.txt"); // Список текстовых файлов
            foreach (FileInfo file in files2)
            {
                Console.WriteLine("\nАтрибуты файла {0}", file.Name);
                String[] attributes = file.Attributes.ToString().Split(',');
                for (int i = 0; i < attributes.Length; i++)
                    Console.WriteLine(attributes[i].Trim());
            }

            // Определяем, имеет ли первый файл коллекции files2 атрибут ReadOnly 
            if ((files2[0].Attributes & FileAttributes.ReadOnly) == FileAttributes.ReadOnly)
                Console.WriteLine(Environment.NewLine   // Новая строка
                    + "Файл {0} имеет атрибут ReadOnly", files2[0].Name);
            else
                Console.WriteLine("\n"                  // Новая строка
                    + "Файл {0} не имеет атрибут ReadOnly", files2[0].Name);

            // Исключаем из первого объекта добавленные ранее атрибуты
            foreach (FileInfo file in files1)
            {
                // Исключаем атрибуты
                file.Attributes &= ~mask; // Побитовое умножение на инвертированную маску
            }

            // Печатаем результат через второй объект
            // Если открыть комментарные скобки - результат будет неверным!!!
            //*
            for (int i = 0; i < files2.Length; i++)
                files2[i].Refresh();    // Приводим в соответствие с состоянием файлов
            //*/
            foreach (FileInfo file in files2)
            {
                Console.WriteLine("\nАтрибуты файла {0}", file.Name);
                String[] attributes = file.Attributes.ToString().Split(',');
                for (int i = 0; i < attributes.Length; i++)
                    Console.WriteLine(attributes[i].Trim());
            }

            // Определяем, имеет ли первый файл коллекции files2 атрибут ReadOnly 
            if ((files2[0].Attributes & FileAttributes.ReadOnly) == FileAttributes.ReadOnly)
                Console.WriteLine(Environment.NewLine   // Новая строка
                    + "Файл {0} имеет атрибут ReadOnly", files2[0].Name);
            else
                Console.WriteLine("\n"                  // Новая строка
                    + "Файл {0} не имеет атрибут ReadOnly", files2[0].Name);

            Console.ReadLine();
        }
    }
}
