﻿using System;
using System.Collections.Generic;
using System.Text;
    
using System.IO;
using DEBUG = System.Diagnostics.Debug; // Псевдоним класса
    
namespace App5
{
    class Program
    {
        static void Main(string[] args)
        {
            String currentDirectory = Directory.GetCurrentDirectory();  // Каталог сборки
            String message = "Без использования Path\n".ToUpper();
            message += "currentDirectory: " + currentDirectory + "\n";
            DirectoryInfo directory = new DirectoryInfo(currentDirectory);
            FileInfo[] files = directory.GetFiles("*.exe"); // Список файлов по шаблону
            FileInfo file;
            if (files.Length > 0)
                file = files[0];    // Берем первый попавшийся для анализа
            else
                return;             // Нечего анализировать
    
            string fullName = file.FullName;
            string name = file.Name;
            message += "fullName: " + fullName + "\n";
            message += string.Format("name: {0}\n", name);
    
            message += string.Format("\nС использованием Path\n").ToUpper();
            String path;
            message += "path = Path.GetDirectoryName(fullName): "
                + (path = Path.GetDirectoryName(fullName)) + "\n";
            message += "Path.GetFullPath(name): "
                + Path.GetFullPath(name) + "\n";
            message += "Path.GetFileName(fullName): "
                + Path.GetFileName(fullName) + "\n";
            message += "Path.GetFileNameWithoutExtension(fullName): "
                + Path.GetFileNameWithoutExtension(fullName) + "\n";
            message += "Path.GetExtension(fullName): "
                + Path.GetExtension(fullName) + "\n";
            message += "Path.Combine(path, name): "
                + Path.Combine(path, name) + "\n";
            message += "Path.GetPathRoot(path): "
                + Path.GetPathRoot(path) + "\n";
            message += "Path.GetPathRoot(fullName): "
                + Path.GetPathRoot(fullName) + "\n";
            message += "Path.GetRandomFileName(): "
                + Path.GetRandomFileName() + "\n";
            message += "Path.GetRandomFileName(): "
                + Path.GetRandomFileName() + "\n";
            message += "Path.GetRandomFileName(): "
                + Path.GetRandomFileName() + "\n";
            message += "Path.GetTempFileName(): "
                + Path.GetTempFileName() + "\n";
            message += "Path.GetTempFileName(): "
                + Path.GetTempFileName() + "\n";
            message += "Path.GetTempPath(): "
                + Path.GetTempPath() + "\n";
            message += "AltDirectorySeparatorChar: '"
                + Path.AltDirectorySeparatorChar + "'\n";
            message += "DirectorySeparatorChar: '"
                + Path.DirectorySeparatorChar + "'\n";
            message += "PathSeparator: '"
                + Path.PathSeparator + "'\n";
            message += "VolumeSeparatorChar: '"
                + Path.VolumeSeparatorChar + "'\n";
    
            String unsafeFileName = "..\\..\\..\\" + name;    // Опасное имя файла
            String safeFileName = Path.GetFileName(unsafeFileName);
            message += "\nОпасное имя файла: " + unsafeFileName + "\n";
            message += "Безопасное имя файла: " + safeFileName + "\n";
            message += "Полное опасное имя: " + Path.Combine(path, unsafeFileName) + Environment.NewLine;
            message += "Полное опасное имя: " + Path.GetFullPath(Path.Combine(path, unsafeFileName)) + "\n";
            message += "Полное безопасное имя: " + Path.Combine(path, safeFileName);
    
            // Печать результатов
            Console.WriteLine(message); // На консоль
            DEBUG.WriteLine(message);   // На панель Output
    
            Console.ReadLine(); // Задержка окна
        }
    }
}
