﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
using System.IO;
    
namespace App6
{
    public partial class Form1 : Form
    {
        Panel fileDetails;// Поле, инициализируется неявно нулевым адресом: null
    
        public Form1()
        {
            InitializeComponent();
    
            // Программные донастройки
            gridFile.ReadOnly = true;       // Только для просмотра
            gridFile.SelectionMode =
                DataGridViewSelectionMode.FullRowSelect;// Выделять всю строку
    
            // Начальная информация
            currentPath = Directory.GetCurrentDirectory();
            ShowDirectoryContents(currentPath);
            fileDetails = splitContainer1.Panel2;
            fileDetails.AutoScroll = true;
        }
    
        String currentPath;// Поле, инициализируется неявно пустой строкой
        void ShowDirectoryContents(String path)
        {
            // Получить объект справки текущего каталога
            DirectoryInfo curDir = new DirectoryInfo(path);
    
            // Получить для текущего каталога 
            // объекты справки файлов и подкаталогов
            FileInfo[] files = curDir.GetFiles();
            DirectoryInfo[] dirs = curDir.GetDirectories();
            lblCurrentDir.Text = "Текущий каталог: " + path;
    
            // Привязываем к элементам отображения
            listDir.DataSource = dirs;
            listDir.DisplayMember = "Name"; // Отображаемый вектор
            listDir.ValueMember = "Name";   // Скрытый вектор
            gridFile.DataSource = files;    // Показываем все
        }
    
        private void btnUp_Click(object sender, EventArgs e)
        {
            // Уже "Мой компьютер" и выше некуда
            if (currentPath == String.Empty)
                return;
            // Хотим подняться выше текущего корня,
            // поэтому выводим доступные устройства
            else if (currentPath == Path.GetPathRoot(currentPath))
            {
                System.Collections.ArrayList array =
                    new System.Collections.ArrayList();
                DriveInfo[] drives = DriveInfo.GetDrives();
                // Фильтруем готовые устройства
                foreach (DriveInfo drive in drives)
                {
                    if (drive.IsReady)
                    {
                        String name = drive.Name;
                        name = name.Split('\\')[0];// Убираем слэш
                        array.Add(name);
                    }
                }
    
                listDir.DataSource = array; // Привязываем список доступных устройств
                gridFile.DataSource = null; // Нет файлов
                currentPath = String.Empty; // Пути нет
                lblCurrentDir.Text = "Мой компьютер";   // Меняем заголовок метки
    
                return;
            }
            // Находимся ниже корня текущего устройства
            // и есть куда подниматься
            else
            {
                String path = Path.Combine(currentPath, "..");
                currentPath = Path.GetFullPath(path);   // Этажом выше без '..'
                ShowDirectoryContents(currentPath);
            }
        }
    
        private void listDir_DoubleClick(object sender, EventArgs e)
        {
            String dir = listDir.SelectedValue.ToString();// Извлекаем из списка
            currentPath = Path.Combine(currentPath, dir);
            if (currentPath.IndexOf('\\') == -1)
                currentPath += "\\";    // Если только что спустились в корень
            ShowDirectoryContents(currentPath);
        }
    
        private void gridFile_Click(object sender, EventArgs e)
        {
            if (gridFile.Rows.Count == 0)
                return; // Нечего выделять
    
            // Локальные переменные инициализировать обязательно, а поля нет
            int selectIndex = gridFile.CurrentCell.RowIndex;
            DataGridViewRow row = gridFile.Rows[selectIndex];
            DataGridViewCellCollection cells = gridFile.Rows[selectIndex].Cells;
            String message = "";
    
            // Извлекаем информацию из текущей строки
            for (int i = 0; i < gridFile.Columns.Count; i++)
            {
                String columnName = gridFile.Columns[i].Name;
                String columnValue = row.Cells[i].Value.ToString();
                message += columnName + ":  " + columnValue + "\n";
            }
    
            // Создаем окно и выводим информацию
            Form frm = new Form();
            frm.Width = 500;
            frm.Height = 320;
            frm.Text = "Подробности";   // Заголовок окна
            frm.MinimizeBox = false;    // Убираем системные кнопки
            frm.MaximizeBox = false;    // Убираем системные кнопки
            frm.ShowInTaskbar = false;  // Не отображать в панели задач
            frm.StartPosition = FormStartPosition.CenterParent;// По центру родителя
    
            // Промежуточная панель - для скролирования
            Panel panel = new Panel();
            panel.BackColor = System.Drawing.Color.White;
            panel.Dock = DockStyle.Fill;
            panel.AutoScroll = true;
            frm.Controls.Add(panel);// Отдаем окну
    
            // Отображающая текстовая метка
            Label lbl = new Label();
            lbl.AutoSize = true;
            lbl.Parent = panel;     // Отдаем панели
            // panel.Controls.Add(lbl);// Вариант - отдаем панели
            lbl.Text = message;
    
            // Заряжаем дополнительные окна вывода раньше диалога
            Console.Clear(); Console.Write(message); // !!!!!!!!!!!!!!!!!!!!
            System.Diagnostics.Debug.Write(message + Environment.NewLine);
    
            frm.ShowDialog();   // Показываем окно в модальном режиме
        }
    }
}
