﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
    
// Подключение дополнительного пространства имен
using System.IO;
    
namespace App7
{
    public partial class Form1 : Form
    {
        // Объявили и инициализировали поле для объекта параметров
        //MySettings settings = new MySettings(); 
        Properties.Settings settings = new App7.Properties.Settings();
        public Form1()
        {
            InitializeComponent();
    
            // Привязка именованных параметров к 
            // сохраняемым свойствам элементов управления
            /*////////////////////////////////////////////////////
            txtMin.DataBindings.Add(new Binding("Text", settings, "Min"));
            txtStep.DataBindings.Add(new Binding("Text", settings, "Step"));
            txtCount.DataBindings.Add(new Binding("Text", settings, "Count"));
            txtFileName.DataBindings.Add(new Binding("Text", settings, "FileName"));
            txtDirTarget.DataBindings.Add(new Binding("Text", settings, "DirTarget"));
            txtSeries.DataBindings.Add(new Binding("Text", settings, "Series"));
            ////////////////////////////////////////////////////*/
    
            // Чтение параметров
            //*////////////////////////////////////////////////////
            txtMin.Text = settings.Min;
            txtStep.Text = settings.Step;
            txtCount.Text = settings.Count;
            txtFileName.Text = settings.FileName;
            txtDirTarget.Text = settings.DirTarget;
            txtSeries.Text = settings.Series;
            ////////////////////////////////////////////////////*/
        }
    
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Запись параметров
            //*////////////////////////////////////////////////////
            settings.Min = txtMin.Text;
            settings.Step = txtStep.Text;
            settings.Count = txtCount.Text;
            settings.FileName = txtFileName.Text;
            settings.DirTarget = txtDirTarget.Text;
            settings.Series = txtSeries.Text;
            ////////////////////////////////////////////////////*/
    
            settings.Save();
        }
   
        int min, step, count, max;
        FolderBrowserDialog dialogFolder = new FolderBrowserDialog();
        private void Form1_Load(object sender, EventArgs e)
        {
            if (txtDirTarget.Text == String.Empty ||
                Directory.Exists(txtDirTarget.Text) == false)
            {
                dialogFolder.RootFolder =
                    System.Environment.SpecialFolder.MyComputer;
                dialogFolder.SelectedPath = "";
                txtDirTarget.Text = String.Empty;
            }
            else
            {
                dialogFolder.SelectedPath = txtDirTarget.Text;
            }
    
            dialogFolder.Description = 
                "Выберите место размещения текстового файла";
    
            min = Convert.ToInt32(txtMin.Text);
            step = Convert.ToInt32(txtStep.Text);
            count = Convert.ToInt32(txtCount.Text);
            max = min + step * count;
            txtMax.Text = max.ToString();
    
            // Маркируем элементы для распознавания в общем обработчике
            txtMin.Name = "Min";
            txtStep.Name = "Step";
            txtCount.Name = "Count";
        }
    
        private void Form1_DoubleClick(object sender, EventArgs e)
        {
            settings.DirTarget = "";
            txtDirTarget.Text = "";
            dialogFolder.SelectedPath = "";
            dialogFolder.RootFolder =
                System.Environment.SpecialFolder.MyComputer;
        }

        private void btnDirTarget_Click(object sender, EventArgs e)
        {
            dialogFolder.ShowDialog();
            txtDirTarget.Text = dialogFolder.SelectedPath;
            txtDirTarget.Focus();// Без этого не сохраняет параметр в settings
        }

        private void txtDirTarget_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = true;
        }

        private void txtDirTarget_KeyDown(object sender, KeyEventArgs e)
        {
            e.Handled = true;
        }

        bool isNumber;
        private void txt_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            isNumber =
                e.KeyCode >= Keys.D0 && e.KeyCode <= Keys.D9 // keyboard - основная клавиатура
                || e.KeyCode >= Keys.NumPad0 && e.KeyCode <= Keys.NumPad9 // keypad - дополнительная клавиатура
                || e.KeyCode == Keys.Back;
        }
    
        private void txt_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            TextBox txtBox = sender as TextBox;// Приведение ссылки 
            int maxLength = int.MaxValue.ToString().Length - 1;// Длина ввода (с запасом)
    
            // Запрещаем в текстовом поле лишние символы 
            // и ограничиваем длину пользовательского ввода
            if (!isNumber || txtBox.Text.Length >= maxLength)
                e.Handled = true;
        }

        private void result_TextChanged(object sender, EventArgs e)
        {
            // Следим, чтобы редактируемое поле не оказалось пустым
            TextBox txtBox = (TextBox)sender;// Приводим ссылку к типу элемента
            if (txtBox.Text == String.Empty)
            {
                switch (txtBox.Name)
                {
                    case "Min":
                        txtMin.Text = "0";
                        break;
                    case "Step":
                        txtStep.Text = "0";
                        break;
                    case "Count":
                        txtCount.Text = "0";
                        break;
                }
            }
    
            // Конвертируем разными способами
            min = Convert.ToInt32(txtMin.Text);
            step = Int32.Parse(txtStep.Text);
            int.TryParse(txtCount.Text, out count);
    
            max = min + step * count;
            txtMax.Text = max.ToString();
        }

        private void btnExecute_Click(object sender, System.EventArgs e)
        {
            String fileName = txtFileName.Text; // Копируем ссылку для удобства
    
            // Заполнено ли текстовое поле
            if (fileName.Length <= 0 || txtDirTarget.Text == String.Empty)
            {
                MessageBox.Show("Вы не задали имя файла или каталога",
                    "Ошибка",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Stop);
                return;
            }
    
            // Есть ли расширение txt
            int pos0 = fileName.LastIndexOf('.');// Ищем с конца
            if (pos0 == -1 || !String.Equals(fileName.Substring(pos0), ".txt"))
            {
                MessageBox.Show("Вы не задали расширение .txt",
                    "Ошибка",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Stop);
                return;
            }
    
            // Не допускать составное имя
            int pos1 = fileName.IndexOf('.');   // Ищем с начала
            if (pos0 != pos1)   // Если точек несколько
            {
                MessageBox.Show("Задайте одно расширение .txt",
                    "Ошибка",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Stop);
                return;
            }
    
            // Добавляем путь = полное имя файла
            fileName = Path.Combine(txtDirTarget.Text, fileName);
    
            if (!File.Exists(fileName))
            {
                FileStream stream = File.Create(fileName);// Создать файл
                stream.Close(); // Освободить ресурс
            }
    
            Console.Clear();    // Очистить консоль
            Random rand = new Random();// Генератор случайных чисел по равномерному закону
            int result;
            StreamWriter writeFile = new StreamWriter(fileName, false, 
                System.Text.ASCIIEncoding.GetEncoding(1251));
            for (int i = 0; i < count; i++)
            {
                result = min + i * step + rand.Next(step);
                Console.WriteLine(txtSeries.Text.Trim() + result.ToString());   // Выводим на консоль
                writeFile.WriteLine(txtSeries.Text.Trim() + result.ToString()); // Выводим в файл
            }
            writeFile.WriteLine("--------");    // Отделяем итог
            writeFile.WriteLine(count.ToString() + " шт.");
    
            writeFile.Close();   // Освободить ресурс
        }
    }
}
